;;;
;;; gus.h
;;;
;;; created: <Fri Jun  4 16:19:53 1999>
;;; last modified: <Tue May  9 18:50:30 2000>
;;;
;;; Christian Fowelin <christian@fowelin.de>
;;;
;;; Released under the LGPL (file COPYING).
;;; 

%ifndef _gus_h_
%define _gus_h_


;;;
;;; _GUS_cmd
;;;
;;; %1 != eax !!!!!!!!!!!!!!
%macro _GUS_cmd 5
%ifidni %1,eax
 %error "_GUS_cmd: Please do not use 'eax' as %1."
%endif
%ifidni %1,dword [eax]
 %error "_GUS_cmd: Please do not use '[eax]' as %1."
%endif
%define eventsize 8
	SEQ_needbuf eventsize
	__push eax, %5, %4, %3
	mov [ebp-eventsize+0],byte SEQ_PRIVATE
	mov eax,%1		; *_snd
	mov eax,[eax+snd.device]
	mov [ebp-eventsize+1],al
	mov [ebp-eventsize+2],byte %2
	pop eax
	mov [ebp-eventsize+3],al
	pop eax
	mov [ebp-eventsize+4],ax
	pop eax
	mov [ebp-eventsize+6],ax
	;; execute SEQ command
	mov eax,ebp
	sub eax,byte eventsize
	SEQ_sendevent %1, eax, dword eventsize
	pop eax
	SEQ_adjbuf
%endm



;;;*
;;;* GUS_numvoices
;;;*
;;;*  In: GUS_numvoices *_snd, num
;;;*  Out: -
;;;*
;;;*  Set number of voices (16..31).
;;;*
%macro GUS_numvoices 2
	_GUS_cmd %1, _GUS_NUMVOICES, dword 0, %2, dword 0
%endm


;;;*
;;;* GUS_voiceon
;;;*
;;;*  In: GUS_voiceon *_snd, voice, mode
;;;*  Out: -
;;;*
;;;*  Start voice with mode.
;;;*
%macro GUS_voiceon 3
	_GUS_cmd %1, _GUS_VOICEON, %2, %3, dword 0
%endm


;;;*
;;;* GUS_voiceoff
;;;*
;;;*  In: GUS_voiceoff *_snd, voice
;;;*  Out: -
;;;*
;;;*  Stop voice.
;;;*
%macro GUS_voiceoff 2
	_GUS_cmd %1, _GUS_VOICEOFF, %2, dword 0, dword 0
%endm


;;;*
;;;* GUS_voicefade
;;;*
;;;*  In: GUS_voicefade *_snd, voice
;;;*  Out: -
;;;*
;;;*  Stop voice smoothly.
;;;*
%macro GUS_voicefade 2
	_GUS_cmd %1, _GUS_VOICEFADE, %2, dword 0, dword 0
%endm


;;;*
;;;* GUS_voicemode
;;;*
;;;*  In: GUS_voicemode *_snd, voice, mode
;;;*  Out: -
;;;*
;;;*  Set voice mode.
;;;*
%macro GUS_voicemode 3
	_GUS_cmd %1, _GUS_VOICEMODE, %2, %3, dword 0
%endm


;;;*
;;;* GUS_voicebala
;;;*
;;;*  In: GUS_voicebala *_snd, voice, balance (0=left, 7=middle and 15=right,
;;;*      default 7)
;;;*  Out: -
;;;*
;;;*  Set voice balance.
;;;*
%macro GUS_voicebala 2
	_GUS_cmd %1, _GUS_VOICEBALA, %2, %3, dword 0
%endm


;;;*
;;;* GUS_voicefreq
;;;*
;;;*  In: GUS_voicefreq *_snd, voice, frequency
;;;*  Out: -
;;;*
;;;*  Set voice frequency.
;;;*
;;; %1 != eax|ebx !!!!!!!!!!!!!!
%macro GUS_voicefreq 3
%ifidni %1,ebx
 %error "_GUS_voicefreq: Please do not use 'ebx' as %1."
%endif
%ifidni %1,dword [ebx]
 %error "_GUS_voicefreq: Please do not use '[ebx]' as %1."
%endif
	__push eax, ebx, %3
	pop eax
	mov ebx,eax
	and eax,0xffff
	shr ebx,16
	_GUS_cmd %1, _GUS_VOICEFREQ, %2, eax, ebx
	__pop ebx, eax
%endm


;;;*
;;;* GUS_voicevol
;;;*
;;;*  In: GUS_voicevol *_snd, voice, volume
;;;*  Out: -
;;;*
;;;*  Set voice volume (0xfff=max, 0xeff=half, 0x000=off).
;;;*
%macro GUS_voicevol 3
	_GUS_cmd %1, _GUS_VOICEVOL, %2, %3, dword 0
%endm


;;;*
;;;* GUS_voicevol2
;;;*
;;;*  In: GUS_voicevol2 *_snd, voice, volume
;;;*  Out: -
;;;*
;;;*  Set voice volume (0xfff=max, 0xeff=half, 0x000=off).
;;;*  Does not change hw.
;;;*
%macro GUS_voicevol2 3
	_GUS_cmd %1, _GUS_VOICEVOL2, %2, %3, dword 0
%endm


;;;*
;;;* GUS_ramprange
;;;*
;;;*  In: GUS_ramprange *_snd, voice, low, high
;;;*  Out: -
;;;*
;;;*  Set voice ramprange.
;;;*
%macro GUS_ramprange 4
	_GUS_cmd %1, _GUS_RAMPRANGE, %2, %3, %4
%endm


;;;*
;;;* GUS_ramprate
;;;*
;;;*  In: GUS_ramprate *_snd, voice, scale, rate
;;;*  Out: -
;;;*
;;;*  Set voice ramprate.
;;;*
%macro GUS_ramprate 4
	_GUS_cmd %1, _GUS_RAMPRATE, %2, %3, %4
%endm


;;;*
;;;* GUS_rampmode
;;;*
;;;*  In: GUS_rampmode *_snd, voice, mode
;;;*  Out: -
;;;*
;;;*  Set voice rampmode.
;;;*
%macro GUS_rampmode 3
	_GUS_cmd %1, _GUS_RAMPMODE, %2, %3, dword 0
%endm


;;;*
;;;* GUS_rampon
;;;*
;;;*  In: GUS_rampon *_snd, voice, p1
;;;*  Out: -
;;;*
;;;*  Set voice ramp on.
;;;*
%macro GUS_rampon 3
	_GUS_cmd %1, _GUS_RAMPON, %2, %3, dword 0
%endm


;;;*
;;;* GUS_rampoff
;;;*
;;;*  In: GUS_rampoff *_snd, voice
;;;*  Out: -
;;;*
;;;*  Set voice ramp off.
;;;*
%macro GUS_rampoff 2
	_GUS_cmd %1, _GUS_RAMPOFF, %2, dword 0, dword 0
%endm


;;;*
;;;* GUS_volume_scale
;;;*
;;;*  In: GUS_volume_scale *_snd, voice, p1, p2
;;;*  Out: -
;;;*
;;;*  Change the volume calculation constants for all voices.
;;;*
%macro GUS_volume_scale 4
	_GUS_cmd %1, _GUS_VOLUME_SCALE, %2, %3, %4
%endm


;;;*
;;;* GUS_voice_pos
;;;*
;;;*  In: GUS_voice_pos *_snd, voice, pos
;;;*  Out: -
;;;*
;;;*  Set voice position.
;;;*
%macro GUS_voice_pos 3
	_GUS_cmd %1, _GUS_VOICE_POS, %2, %3, dword 0
%endm


%endif	; _gus_h_


;;; Local Variables:
;;;  mode:asm
;;;  eval:(load-library "time-stamp")
;;;  eval:(make-local-variable 'write-file-hooks)
;;;  eval:(add-hook 'write-file-hooks 'time-stamp)
;;;  eval:(setq time-stamp-start "last modified:[ 	]+\\\\?[\"<]+")
;;;  eval:(setq time-stamp-format "%3a %3b %2d %02H:%02M:%02S %y")
;;; End: