;;;
;;; oss.h
;;;
;;; created: <Fri Jun  4 16:19:53 1999>
;;; last modified: <Sat Jun 17 19:18:28 2000>
;;;
;;; Christian Fowelin <christian@fowelin.de>
;;;
;;; Released under the LGPL (file COPYING).
;;; 

;;;
;;; Taken from linux/include/linux/soundcard.h and
;;; linux/include/linux/ultrasnd.h
;;;

%ifndef _oss_h_
%define _oss_h_

%include "linux/types.h"

%define _PATCHKEY(id) ((id<<8)|0xfd)

struc remove_sample
.devno:		INT 1		; Synthesizer #
.bankno:	INT 1		; MIDI bank # (0=General MIDI)
.instrno:	INT 1		; MIDI instrument number
endstruc

struc patch_info
.key:		U_SHORT 1		; Use WAVE_PATCH here
.device_no:	SHORT 1		; Synthesizer number
.instr_no:	SHORT 1		; Midi pgm#
		alignb 4	; My gcc alignes this to 4
.mode:		U_INT 1
.len:		INT 1		; Size of the wave data in bytes
.loop_start:	INT 1		; Byte offsets from the beginning
.loop_end:	INT 1		; Byte offsets from the beginning
.base_freq:	U_INT 1
.base_note:	U_INT 1
.high_note:	U_INT 1
.low_note:	U_INT 1
.panning:	INT 1		; -128=left, 127=right
.detuning:	INT 1
.env_rate:	U_CHAR 6		; GUS HW ramping rate
.env_offset:	U_CHAR 6		; 255 == 100%
.tremolo_sweep:	U_CHAR 1
.tremolo_rate:	U_CHAR 1
.tremolo_depth:	U_CHAR 1
.vibrato_sweep:	U_CHAR 1
.vibrato_rate:	U_CHAR 1
.vibrato_depth:	U_CHAR 1
		alignb 4	; My gcc alignes this to 4
.scale_frequency:	INT 1
.scale_factor:	U_INT 1		; from 0 to 2048 or 0 to 2
.volume:	INT 1
.fractions:	INT 1
.reserved1:	INT 1
.spare:		INT 2
.data:		CHAR 1		; The waveform data starts here
endstruc


struc synth_info		; Read only
.name:		CHAR 30
		alignb 4	; My gcc alignes this to 4
.device:		INT 1		; 0-N. INITIALIZE BEFORE CALLING
.synth_type:	INT 1
.synth_subtype:	INT 1
.perc_mode:	INT 1		; No longer supported
.nr_voices:	INT 1
.nr_drums:	INT 1		; Obsolete field
.instr_bank_size:	INT 1
.capabilities:	U_INT 1
.dummies:	INT 19		; Reserve space
endstruc

%endif	; _oss_h_


;;; Local Variables:
;;;  mode:asm
;;;  eval:(load-library "time-stamp")
;;;  eval:(make-local-variable 'write-file-hooks)
;;;  eval:(add-hook 'write-file-hooks 'time-stamp)
;;;  eval:(setq time-stamp-start "last modified:[ 	]+\\\\?[\"<]+")
;;;  eval:(setq time-stamp-format "%3a %3b %2d %02H:%02M:%02S %y")
;;; End: