;;;
;;; structs.h
;;;
;;; created: <Fri Jul  9 07:50:19 1999>
;;; last modified: <Sun Jul  2 23:00:38 2000>
;;;
;;; Christian Fowelin <christian@fowelin.de>
;;;
;;; Released under the LGPL (file COPYING).
;;; 

;;; This defines structs from the kernel in nasm syntax

%ifndef _structs_h_
%define _structs_h_
%include "linux/types.h"

;;; include/asm/termbits.h
struc termios
.c_iflag	U_INT 1		; input mode flags
.c_oflag	U_INT 1		; output mode flags
.c_cflag	U_INT 1		; control mode flags
.c_lflag	U_INT 1		; local mode flags
.c_line		U_CHAR 1	; line discipline
.c_cc		U_CHAR 19	; control characters
endstruc


;;; include/linux/time.h
struc timespec
.tv_sec		LONG 1		; seconds
.tv_nsec	LONG 1		; nanoseconds
endstruc


;;; include/linux/utsname.h
struc new_utsname
.sysname:	CHAR 65
.nodename:	CHAR 65
.release:	CHAR 65
.version:	CHAR 65
.machine:	CHAR 65
.domainname:	CHAR 65
endstruc


;;; include/linux/ipc.h
struc ipc_perm
.key:		INT 1
.uid:		U_SHORT 1
.gid:		U_SHORT 1
.cuid:		U_SHORT 1
.cgid:		U_SHORT 1
.mode:		U_SHORT 1
.seq:		U_SHORT 1
endstruc

;;; include/linux/shm.h
struc shmid_ds
.shm_perm:	resb ipc_perm_size ; operation perms
.shm_segsz:	INT 1		; size of segment (bytes)
.shm_atime:	LONG 1		; last attach time
.shm_dtime:	LONG 1		; last detach time
.shm_ctime:	LONG 1		; last change time
.shm_cpid:	U_SHORT 1	; pid of creator
.shm_lpid:	U_SHORT 1	; pid of last operator
.shm_nattch:	U_SHORT 1	; no. of current attaches
.shm_unused:	U_SHORT 1	; compatibility
.shm_unused2:	resd 1		; ditto - used by DIPC
.shm_unused3:	resd 1		; unused
endstruc


%endif	; _structs_h_


;;; Local Variables:
;;;  mode:asm
;;;  eval:(load-library "time-stamp")
;;;  eval:(make-local-variable 'write-file-hooks)
;;;  eval:(add-hook 'write-file-hooks 'time-stamp)
;;;  eval:(setq time-stamp-start "last modified:[ 	]+\\\\?[\"<]+")
;;;  eval:(setq time-stamp-format "%3a %3b %2d %02H:%02M:%02S %y")
;;; End: