;;;
;;; x_struc_l.h
;;;
;;; created: <Wed Mar  8 21:33:40 2000>
;;; last modified: <Sat Oct 14 18:22:42 2000>
;;;
;;; Christian Fowelin <christian@fowelin.de>
;;;
;;; Released under the LGPL (file COPYING).
;;;
;;; Structures used by libASM
;;;

%ifndef _x_struc_l_h_
%define _x_struc_l_h_

;;;*
;;;* This struc (dpystruc) is used by libASM to control the stocket connected to
;;;* the Xserver opend by XOpenDisplay.
;;;*
;;;* .fd:			fd of X socket
;;;* .info:			pointer to connection reply from server
;;;* .maxRequestSize:		maximum request size (bytes)
;;;* .resource_id:
;;;* .resource_base:
;;;* .resource_shift:
;;;* .resource_mask:
;;;* .resource_max:
;;;* .major_version:
;;;* .minor_version:
;;;* .vendor:		pointer to vendor string
;;;* .vendor_size:		length of verndor string (4 padded)
;;;* .nformats:		number of formats
;;;* .pformats:		pointer to format structs
;;;* .nscreens:		number of screens
;;;* .pscreens:		pointer to screen structs
;;;* .error_handler:	pointer to error_handler (0: use std handler)
;;;* .event_handler:	pointer to event_handler (0: use std handler)
;;;* .default_screen_nr:	default screen number
;;;* .default_screen:	pointer to default screen structure
;;;* .default_root:		default root window ID
;;;* .default_visualID:	root visual ID
;;;* .default_visualtype:	pointer to default visualtype of default screen
;;;* .default_depth:	default depth of default screen
;;;* .default_colormap:	default colormap of default screen
;;;* .imageByteOrder:	LSBFirst, MSBFirst: Image byte order
;;;* .bitmapBitOrder:	LeastSignificant, MostSign...
;;;* .bitmapScanlineUnit:	8, 16, 32
;;;  .bitmapScanlinePad:	8, 16, 32
;;;* .XC_MISC_opcode:	Opcode for XC-Misc Extension
;;;* .MIT_SHM_opcode:	Opcode for MIT-SHM Extension
;;;*
;;; This defines the structure used by libASM to control the stocket connected
;;; to the Xserver opend by XOpenDisplay.
;;;
struc dpystruc
.fd:			resd 1	; fd of X socket
.info:			resd 1	; pointer to connection reply from server
.maxRequestSize:	resd 1	; maximum request size (bytes)

.resource_id:		resd 1
.resource_base:		resd 1
.resource_shift:	resd 1
.resource_mask:		resd 1
.resource_max:		resd 1

.major_version:		resd 1
.minor_version:		resd 1
.vendor:		resd 1	; pointer to vendor string
.vendor_size:		resd 1	; length of verndor string (4 padded)

.nformats:		resd 1	; number of formats
.pformats:		resd 1	; pointer to format structs
.nscreens:		resd 1	; number of screens
.pscreens:		resd 1	; pointer to screen structs

.error_handler:		resd 1	; pointer to error_handler (0: use std handler)
.event_handler:		resd 1	; pointer to event_handler (0: use std handler)

.default_screen_nr:	resd 1	; default screen number
.default_screen:	resd 1	; pointer to default screen structure
.default_root:		resd 1	; default root window ID
.default_visualID:	resd 1	; root visual ID
.default_visualtype:	resd 1	; pointer to default visualtype of default screen
.default_depth:		resd 1	; default depth of default screen
.default_colormap:	resd 1	; default colormap of default screen

.imageByteOrder:	resd 1	; LSBFirst, MSBFirst: Image byte order
.bitmapBitOrder:	resd 1	; LeastSignificant, MostSign...
.bitmapScanlineUnit:	resd 1	; 8, 16, 32
.bitmapScanlinePad:	resd 1	; 8, 16, 32

.XC_MISC_opcode:	resd 1	; Opcode for XC-Misc Extension
.MIT_SHM_opcode:	resd 1	; Opcode for MIT-SHM Extension
endstruc



;;;*
;;;* This struc (ximagestruc) is used by libASM to control a (shared) image
;;;*
;;;* .data:			Pointer to image data
;;;* .obdata:		Pointer to shminfo
;;;* .width:		image width
;;;* .height:		image height
;;;* .depth:		image depth
;;;* .format:		image format
;;;* .bitmap_unit:
;;;* .bitmap_bit_order:
;;;* .bitmap_pad:
;;;* .xoffset:
;;;* .red_mask:
;;;* .green_mask:
;;;* .blue_mask:
;;;* .bits_per_pixel:
;;;* .bytes_per_line:
;;;*
struc ximagestruc
.data:			resd 1	; Pointer to image data
.obdata:		resd 1	; Pointer to shminfo
.width:			resd 1	; image width
.height:		resd 1	; image height
.depth:			resd 1	; image depth
.format:		resd 1	; image format
.bitmap_unit:		resd 1
.bitmap_bit_order:	resd 1
.bitmap_pad:		resd 1
.xoffset:		resd 1
.red_mask:		resd 1
.green_mask:		resd 1
.blue_mask:		resd 1
.bits_per_pixel:	resd 1
.bytes_per_line:	resd 1
endstruc

%endif	; _x_struc_l_h_



;;; Local Variables:
;;;  mode:asm
;;;  eval:(load-library "time-stamp")
;;;  eval:(make-local-variable 'write-file-hooks)
;;;  eval:(add-hook 'write-file-hooks 'time-stamp)
;;;  eval:(setq time-stamp-start "last modified:[ 	]+\\\\?[\"<]+")
;;;  eval:(setq time-stamp-format "%3a %3b %2d %02H:%02M:%02S %y")
;;; End: