;;;
;;; PipeOUT.s
;;;
;;; created: <Sun May  9 19:01:27 1999>
;;; last modified: <Thu Jun  1 17:06:31 2000>
;;;
;;; Christian Fowelin <christian@fowelin.de>
;;;
;;; Released under the LGPL (file COPYING).
;;;


%include "system.h"
%include "io.h"
%include "sys.h"
%include "string.h"

global _PipeOUT
extern _errno,_argv

%define filename ebx+0
%define argv ebx+4
%define envp ebx+8
%define fildes0 ebx+12
%define fildes1 ebx+16

	section .text
	align 32
_PipeOUT:
	push ebx
	mov ebx,eax

	;; Create pipe fd's
	lea eax,[fildes0]	; effective adress!
	sys_pipe eax
	cmp eax,0
	jne near .err

	;; Fork a child
	sys_fork
	cmp eax,0
	jl near .err

	jne near .parent

	;; This is for the child
	sys_close dword [fildes1] ; memory cell!
	cmp eax,0
	jne near .err
 	sys_dup2 dword [fildes0], dword STDIN
	cmp eax,0
	jl .err

	ExecSP ebx
	jmp .err

	;; This is for the parent
.parent:
	sys_close dword [fildes0]
	cmp eax,0
	jne .err
	mov eax,dword [fildes1]
	pop ebx
	ret

.err:
	mov [_errno],eax
	GetErrorStr dword [_errno]
	mov ecx,dword [_argv]
	WritefSTDERR '%e: _PipeOUT: Could not pipe through %e. (%e)',lf, dword [ecx], dword [filename], eax
	sys_exit dword 1



;;; Local Variables:
;;;  mode:asm
;;;  eval:(load-library "time-stamp")
;;;  eval:(make-local-variable 'write-file-hooks)
;;;  eval:(add-hook 'write-file-hooks 'time-stamp)
;;;  eval:(setq time-stamp-start "last modified:[ 	]+\\\\?[\"<]+")
;;;  eval:(setq time-stamp-format "%3a %3b %2d %02H:%02M:%02S %y")
;;; End: