;;;
;;; Random.s
;;;
;;; created: <Fri May 14 17:52:14 1999>
;;; last modified: <Thu Jun  1 17:07:27 2000>
;;;
;;; Christian Fowelin <christian@fowelin.de>
;;;
;;; Released under the LGPL (file COPYING).
;;;

;;;
;;; Read n (n=1..4) bytes of random from /dev/random. Make sure, that this
;;; device is initialised for 'real' randomness...
;;;  In: Random n
;;;  Out: eax=random
;;;

%include "system.h"
%include "io.h"
%include "string.h"

global _Random
extern _errno,_argv

%define n ebp-8
%define buf ebp-4

	section .text
	align 32
_Random:
	push ebp
	mov ebp,esp
	sub esp,byte 8
	push ebx
	mov [n],eax

	cmp [n],dword 4
	jna .j1
	mov [n],dword 4
.j1:	cmp [n],dword 0
	jne .j2
	mov [n],dword 4
.j2:
	mov [buf],dword 0
	sys_open dword dev, dword O_RDONLY, dword 0
	cmp eax,-1
	jle .err
	push eax
	lea ebx,[buf]		; ebx=ebp-4
	sys_read eax, ebx, dword [n]
	cmp eax,-1
	jle .err
	pop eax
	sys_close eax
	cmp eax,-1
	jle .err
	mov eax,[buf]

	pop ebx
	leave
	ret

.err:
	;; Write prg name, and msg
	mov [_errno],eax
	GetErrorStr dword [_errno]
	mov ebx,dword [_argv]
	WritefSTDERR '%e: _Random: Could not read from %e. (%e)',lf, dword [ebx], dword dev, eax
	;; See ya!
	sys_exit dword 1

	align 32
dev:	db "/dev/random",0



;;; Local Variables:
;;;  mode:asm
;;;  eval:(load-library "time-stamp")
;;;  eval:(make-local-variable 'write-file-hooks)
;;;  eval:(add-hook 'write-file-hooks 'time-stamp)
;;;  eval:(setq time-stamp-start "last modified:[ 	]+\\\\?[\"<]+")
;;;  eval:(setq time-stamp-format "%3a %3b %2d %02H:%02M:%02S %y")
;;; End: