;;;
;;; SEQ_bufdump.s
;;;
;;; created: <Tue Sep 14 00:02:51 1999>
;;; last modified: <Thu Jun  1 17:09:35 2000>
;;;
;;; Christian Fowelin <christian@fowelin.de>
;;;
;;; Released under the LGPL (file COPYING).
;;;

;;;
;;; This defines _seqbuf and _seqbufptr, _seqbufsize and dumps _seqbuf
;;; to SEQ_device_fd
;;;

global _SEQ_bufdump,_seqbuf,_seqbufptr,_seqbufsize
extern _errno,_argv,SEQ_device_info,SEQ_device_fd,SEQ_seqdev

%include "system.h"
%include "seq.h"
%include "io.h"
%include "string.h"

	section .text
	align 32
_SEQ_bufdump:
	__push ebx, ecx
	mov ebx,eax

	;; Dump Buffer
	mov eax,[ebx+snd.seqbufptr]
	inc eax
	lea ecx,[ebx+snd.seqbuf]
	sys_write dword [ebx+snd.fd], ecx, eax
	cmp eax,0
	jnl near .noerr2
	mov [_errno],eax
	jmp .err
.noerr2:
	;; Reset snd.seqbufptr
	mov [ebx+snd.seqbufptr],dword 0

.success:
	;; Success
	mov eax,0
.exit:
	__pop ecx, ebx
	ret

.err:
	GetErrorStr dword [_errno]
	lea ecx,[ebx+snd.seqdev_name]
	mov ebx,dword [_argv]
	WritefSTDERR '%e: _SEQ_bufdump: Error while accessing device %e. (%e)',lf, dword [ebx], ecx, eax
	;; See ya!
	sys_exit dword 1



;;; Local Variables:
;;;  mode:asm
;;;  eval:(load-library "time-stamp")
;;;  eval:(make-local-variable 'write-file-hooks)
;;;  eval:(add-hook 'write-file-hooks 'time-stamp)
;;;  eval:(setq time-stamp-start "last modified:[ 	]+\\\\?[\"<]+")
;;;  eval:(setq time-stamp-format "%3a %3b %2d %02H:%02M:%02S %y")
;;; End: