;;;
;;; SEQ_close.s
;;;
;;; created: <Wed Jun  9 21:39:26 1999>
;;; last modified: <Tue Apr  4 21:34:51 2000>
;;;
;;; Christian Fowelin <christian@fowelin.de>
;;;
;;; Released under the LGPL (file COPYING).
;;;

global _SEQ_close
extern _errno

%include "system.h"
%include "seq.h"
%include "mem.h"


	section .text
	align 32
_SEQ_close:
	push ebx
	mov ebx,eax

	;; Close sequencer
	sys_close dword [eax+snd.fd]
	cmp eax,0
	jl near .err

	;; Free snd struc mem
	MemoryFree ebx
	cmp eax,0
	jl .exit

.success:
	;; Success
	mov eax,0

.exit:
	pop ebx
	ret


.err:
	mov [_errno],eax
	mov eax,-1
	jmp short .exit



;;; Local Variables:
;;;  mode:asm
;;;  eval:(load-library "time-stamp")
;;;  eval:(make-local-variable 'write-file-hooks)
;;;  eval:(add-hook 'write-file-hooks 'time-stamp)
;;;  eval:(setq time-stamp-start "last modified:[ 	]+\\\\?[\"<]+")
;;;  eval:(setq time-stamp-format "%3a %3b %2d %02H:%02M:%02S %y")
;;; End: