;;;
;;; SEQ_writepatch.s
;;;
;;; created: <Thu Jun 17 17:26:09 1999>
;;; last modified: <Thu Jun  1 17:09:26 2000>
;;;
;;; Christian Fowelin <christian@fowelin.de>
;;;
;;; Released under the LGPL (file COPYING).
;;;

global _SEQ_writepatch
extern _errno,_argv,SEQ_device_info,SEQ_device_fd,SEQ_seqdev

%include "system.h"
%include "linux/oss.h"
%include "io.h"
%include "string.h"
%include "seq.h"

%define _snd ebp+0
%define ptr ebp+4
%define len ebp+8

	section .text
	align 32
_SEQ_writepatch:
	__push ebx, ebp
	mov ebp,eax
	mov ebx,[_snd]

	;; Set Synth device_no
	mov eax,[ebx+snd.device]
	mov ebx,dword [ptr]
	mov [ebx+patch_info.device_no],ax

	mov ebx,[_snd]
	sys_write dword [ebx+snd.fd], dword [ptr], dword [len]
	cmp eax,0
	jl .err

.success:
	;; Success
	mov eax,0
.exit:
	__pop ebp, ebx
	ret

.err2:
	mov eax,dword -ENODEV
.err:
	mov [_errno],eax
	GetErrorStr dword [_errno]
	lea ecx,[ebx+snd.seqdev_name]
	mov ebx,dword [_argv]
	WritefSTDERR '%e: _SEQ_writepatch: Could not write on device %e. (%e)',lf, dword [ebx], ecx, eax
	sys_exit dword 1



;;; Local Variables:
;;;  mode:asm
;;;  eval:(load-library "time-stamp")
;;;  eval:(make-local-variable 'write-file-hooks)
;;;  eval:(add-hook 'write-file-hooks 'time-stamp)
;;;  eval:(setq time-stamp-start "last modified:[ 	]+\\\\?[\"<]+")
;;;  eval:(setq time-stamp-format "%3a %3b %2d %02H:%02M:%02S %y")
;;; End: