;;;
;;; GetErrorStr.s
;;;
;;; created: <07.11.1998>
;;; last modified: <Tue Apr  4 13:20:53 2000>
;;;
;;; Christian Fowelin <christian@fowelin.de>
;;;
;;; Released under the LGPL (file COPYING).
;;;

;;;
;;; Errornumber from sys_call -> Errorname (ASCIIZ)
;;;  In: GetErrorStr nr (eax)
;;;  Out: eax=Errname
;;;

%include "system.h"

global _GetErrorStr

	section .text
	align 32
_GetErrorStr:
	__push ecx, edi
	cld
	neg eax
	mov ecx,_geterrornumbers
	mov edi,_geterrornumbertable
	repne scasd
	jecxz .ende
	jmp .weiter
.ende:
	mov eax,-1	; Error

	__pop edi, ecx
	ret

.weiter:
	sub edi,_geterrornumbertable
	shr edi,2
	dec edi
	mov ecx,edi
	mov edi,_geterrornametable

.loop:
	jecxz .gefunden
	push ecx
	mov al,0
	mov ecx,0xffff
	repne scasb
	pop ecx
	dec ecx
	jnz .loop

.gefunden:
	mov eax,edi	; Success

	__pop edi, ecx
	ret

	align 32
_geterrornametable:
	db 'Operation not permitted',0
	db 'No such file or directory',0
	db 'No such process',0
	db 'Interrupted system call',0
	db 'I/O error',0
	db 'No such device or address',0
	db 'Arg list too long',0
	db 'Exec format error',0
	db 'Bad file number',0
	db 'No child processes',0
	db 'Try again',0
	db 'Out of memory',0
	db 'Permission denied',0
	db 'Bad address',0
	db 'Block device required',0
	db 'Device or resource busy',0
	db 'File exists',0
	db 'Cross-device link',0
	db 'No such device',0
	db 'Not a directory',0
	db 'Is a directory',0
	db 'Invalid argument',0
	db 'File table overflow',0
	db 'Too many open files',0
	db ' Not a typewriter',0
	db 'Text file busy',0
	db 'File too large',0
	db 'No space left on device',0
	db 'Illegal seek',0
	db 'Read-only file system',0
	db 'Too many links',0
	db 'Broken pipe',0
	db 'Math argument out of domain of func',0
	db 'Math result not representable',0
	db 'Resource deadlock would occur',0
	db 'File name too long',0
	db 'No record locks available',0
	db 'Function not implemented',0
	db 'Directory not empty',0
	db 'Too many symbolic links encountered',0
	db 'Operation would block',0
	db 'No message of desired type',0
	db 'Identifier removed',0
	db 'Channel number out of range',0
	db 'EL2NSYNC: Level 2 not synchronized',0
	db 'EL3HLT: Level 3 halted',0
	db 'EL3RST: Level 3 reset',0
	db 'Link number out of range',0
	db 'Protocol driver not attached',0
	db 'No CSI structure available',0
	db 'EL2HLT: Level 2 halted',0
	db 'Invalid exchange',0
	db 'Invalid request descriptor',0
	db 'Exchange full',0
	db 'No anode',0
	db 'Invalid request code',0
	db 'Invalid slot',0
	db 'EDEADLOCK',0
	db 'Bad font file format',0
	db 'Device not a stream',0
	db 'No data available',0
	db 'Timer expired',0
	db 'Out of streams resources',0
	db 'Machine is not on the network',0
	db 'Package not installed',0
	db 'Object is remote',0
	db 'Link has been severed',0
	db 'Advertise error',0
	db 'Srmount error',0
	db 'Communication error on send',0
	db 'Protocol error',0
	db 'Multihop attempted',0
	db 'RFS specific error',0
	db 'Not a data message',0
	db 'Value too large for defined data type',0
	db 'Name not unique on network',0
	db 'File descriptor in bad state',0
	db 'Remote address changed',0
	db 'Can not access a needed shared library',0
	db 'Accessing a corrupted shared library',0
	db '.lib section in a.out corrupted',0
	db 'Attempting to link in too many shared libraries',0
	db 'Cannot exec a shared library directly',0
	db 'Illegal byte sequence',0
	db 'Interrupted system call should be restarted',0
	db 'Streams pipe error',0
	db 'Too many users',0
	db 'Socket operation on non-socket',0
	db 'Destination address required',0
	db 'Message too long',0
	db 'Protocol wrong type for socket',0
	db 'Protocol not available',0
	db 'Protocol not supported',0
	db 'Socket type not supported',0
	db 'Operation not supported on transport endpoint',0
	db 'Protocol family not supported',0
	db 'Address family not supported by protocol',0
	db 'Address already in use',0
	db 'Cannot assign requested address',0
	db 'Network is down',0
	db 'Network is unreachable',0
	db 'Network dropped connection because of reset',0
	db 'Software caused connection abort',0
	db 'Connection reset by peer',0
	db 'No buffer space available',0
	db 'Transport endpoint is already connected',0
	db 'Transport endpoint is not connected',0
	db 'Cannot send after transport endpoint shutdown',0
	db 'Too many references: cannot splice',0
	db 'Connection timed out',0
	db 'Connection refused',0
	db 'Host is down',0
	db 'No route to host',0
	db 'Operation already in progress',0
	db 'Operation now in progress',0
	db 'Stale NFS file handle',0
	db 'Structure needs cleaning',0
	db 'Not a XENIX named type file',0
	db 'No XENIX semaphores available',0
	db 'Is a named type file',0
	db 'Remote I/O error',0
	db 'Quota exceeded',0
	db 'No medium found',0
	db 'Wrong medium type',0
	db 'ERESTARTSYS',0
	db 'ERESTARTNOINTR',0
	db 'restart if no handler..',0
	db 'No ioctl command',0
	align 32
_geterrornumbertable:
	dd EPERM,ENOENT,ESRCH,EINTR,EIO,ENXIO,E2BIG,ENOEXEC,EBADF,ECHILD,EAGAIN
	dd ENOMEM,EACCES,EFAULT,ENOTBLK,EBUSY,EEXIST,EXDEV,ENODEV,ENOTDIR
	dd EISDIR,EINVAL,ENFILE,EMFILE,ENOTTY,ETXTBSY,EFBIG,ENOSPC,ESPIPE,EROFS
	dd EMLINK,EPIPE,EDOM,ERANGE,EDEADLK,ENAMETOOLONG,ENOLCK,ENOSYS
	dd ELOOP,ENOTEMPTY,EWOULDBLOCK,ENOMSG,EIDRM,ECHRNG,EL2NSYNC,EL3HLT
	dd EL3RST,ELNRNG,EUNATCH,ENOCSI,EL2HLT,EBADE,EBADR,EXFULL,ENOANO
	dd EBADRQC,EBADSLT,EDEADLOCK,EBFONT,ENOSTR,ENODATA,ETIME,ENOSR,ENONET
	dd ENOPKG,EREMOTE,ENOLINK,EADV,ESRMNT,ECOMM,EPROTO,EMULTIHOP,EDOTDOT
	dd EBADMSG,EOVERFLOW,ENOTUNIQ,EBADFD,EREMCHG,ELIBACC,ELIBBAD,ELIBSCN
	dd ELIBMAX,ELIBEXEC,EILSEQ,ERESTART,ESTRPIPE,EUSERS,ENOTSOCK
	dd EMSGSIZE,EDESTADDRREQ,EPROTOTYPE,ENOPROTOOPT,EPROTONOSUPPORT
	dd ESOCKTNOSUPPORT,EOPNOTSUPP,EPFNOSUPPORT,EAFNOSUPPORT,EADDRINUSE
	dd EADDRNOTAVAIL,ENETDOWN,ENETUNREACH,ENETRESET,ECONNABORTED,ECONNRESET
	dd ENOBUFS,EISCONN,ENOTCONN,ESHUTDOWN,ETOOMANYREFS,ETIMEDOUT,ECONNREFUSED
	dd EHOSTDOWN,EHOSTUNREACH,EALREADY,EINPROGRESS,ESTALE,EUCLEAN,ENOTNAM
	dd ENAVAIL,EISNAM,EREMOTEIO,EDQUOT,ENOMEDIUM,EMEDIUMTYPE,ERESTARTSYS
	dd ERESTARTNOINTR,ERESTARTNOHAND,ENOIOCTLCMD
_geterrornumbers equ $-_geterrornumbertable



;;; Local Variables:
;;;  mode:asm
;;;  eval:(load-library "time-stamp")
;;;  eval:(make-local-variable 'write-file-hooks)
;;;  eval:(add-hook 'write-file-hooks 'time-stamp)
;;;  eval:(setq time-stamp-start "last modified:[ 	]+\\\\?[\"<]+")
;;;  eval:(setq time-stamp-format "%3a %3b %2d %02H:%02M:%02S %y")
;;; End: