;;;
;;; Sleep.s
;;;
;;; created: <Wed Dec 29 19:21:06 1999>
;;; last modified: <Tue May  2 00:09:26 2000>
;;; 
;;; Christian Fowelin <christian@fowelin.de>
;;;
;;; Released under the LGPL (file COPYING).
;;;

;;; In: Sleep sec, nsec ([eax+0] timespec)
;;; Out: eax=0 (on success); eax=-1 (on error)

%include "system.h"
%include "linux/structs.h"

global _Sleep
extern _errno

	section .text
	align 32
_Sleep:
	sys_nanosleep eax, dword 0
	cmp eax,0
	jnl .noerr
	mov [_errno],eax
	mov eax,-1
.noerr:
	ret


;;; Local Variables:
;;;  mode:asm
;;;  eval:(load-library "time-stamp")
;;;  eval:(make-local-variable 'write-file-hooks)
;;;  eval:(add-hook 'write-file-hooks 'time-stamp)
;;;  eval:(setq time-stamp-start "last modified:[ 	]+\\\\?[\"<]+")
;;;  eval:(setq time-stamp-format "%3a %3b %2d %02H:%02M:%02S %y")
;;; End: