;;;
;;; XClearArea.s
;;;
;;; created: <Thu May 18 10:27:18 2000>
;;; last modified: <Mon May 22 23:30:50 2000>
;;;
;;; Christian Fowelin <christian@fowelin.de>
;;;
;;; Released under the LGPL (file COPYING).
;;;

%include "system.h"
%include "x_func.h"
%include "x_def.h"
%include "mem.h"

global _XClearArea

%define dpy ebx+0
%define wid ebx+4
%define x ebx+8
%define y ebx+12
%define width ebx+16
%define height ebx+20
%define exposures ebx+24

%define request ecx

	section .text
	align 32
_XClearArea:
	__push ebx, ecx
	mov ebx,eax
	MemoryAllocate dword 4*4
	cmp eax,-1
	je .end
	mov request,eax

;;; Opcode: ClearArea
	mov [request+0],byte X_ClearArea
;;; exposures
	mov eax,[exposures]
	mov [request+1],al
;;; request length
	mov [request+2],word 4
;;; wid
	mov eax,[wid]
	mov [request+4],eax
;;; x
	mov eax,[x]
	mov [request+8],ax
;;; y
	mov eax,[y]
	mov [request+10],ax
;;; width
	mov eax,[width]
	mov [request+12],ax
;;; height
	mov eax,[height]
	mov [request+14],ax

	XSync dword [dpy], request, dword 4*4 ; 4*(request length)

	push eax
	MemoryFree request
	cmp eax,-1
	pop eax
	jne .end
	mov eax,-1
.end:
	__pop ecx, ebx
	ret


;;; Local Variables:
;;;  mode:asm
;;;  eval:(load-library "time-stamp")
;;;  eval:(make-local-variable 'write-file-hooks)
;;;  eval:(add-hook 'write-file-hooks 'time-stamp)
;;;  eval:(setq time-stamp-start "last modified:[ 	]+\\\\?[\"<]+")
;;;  eval:(setq time-stamp-format "%3a %3b %2d %02H:%02M:%02S %y")
;;; End: