;;;
;;; XCloseDisplay.s
;;;
;;; created: <Sat Nov 13 18:37:00 1999>
;;; last modified: <Sun Apr  9 23:45:57 2000>
;;;
;;; Christian Fowelin <christian@fowelin.de>
;;;
;;; Released under the LGPL (file COPYING).
;;;

;;;
;;; XCloseDisplay: Disconnects from Xserver
;;;
;;; In: XCloseDisplay *dpy (eax)
;;; Out: eax=0 (on success); eax=-1 (on error)
;;;

%include "system.h"
%include "mem.h"
%include "x_struc.h"

global _XCloseDisplay
extern _errno,_argv

	section .text
	align 32
_XCloseDisplay:
	__push ebx, ecx

	mov ebx,[eax+dpystruc.fd]
	mov ecx,[eax+dpystruc.info]
	MemoryFree eax
	MemoryFree ecx

	sys_close ebx
	cmp eax,0
	jnl .end
	mov [_errno],eax
	mov eax,-1
.end:
	__pop ecx, ebx
	ret


;;; Local Variables:
;;;  mode:asm
;;;  eval:(load-library "time-stamp")
;;;  eval:(make-local-variable 'write-file-hooks)
;;;  eval:(add-hook 'write-file-hooks 'time-stamp)
;;;  eval:(setq time-stamp-start "last modified:[ 	]+\\\\?[\"<]+")
;;;  eval:(setq time-stamp-format "%3a %3b %2d %02H:%02M:%02S %y")
;;; End: