;;;
;;; XDeleteProperty.s
;;;
;;; created: <Sat Mar 18 12:04:25 2000>
;;; last modified: <Tue May  9 17:22:48 2000>
;;;
;;; Christian Fowelin <christian@fowelin.de>
;;;
;;; Released under the LGPL (file COPYING).
;;;

%include "system.h"
%include "x_func.h"
%include "x_def.h"
%include "mem.h"

global _XDeleteProperty

%define dpy ebx+0
%define wid ebx+4
%define property ebx+8

%define request ecx

	section .text
	align 32
_XDeleteProperty:
	__push ebx, ecx
	mov ebx,eax
	MemoryAllocate dword 12
	cmp eax,-1
	je .end
	mov request,eax

;;; opcode: DeleteProperty
	mov [request+0],byte X_DeleteProperty
	mov [request+1],byte 0
;;; request length
	mov [request+2],word 3
;;; wid
	mov eax,[wid]
	mov [request+4],eax
;;; property
	mov eax,[property]
	mov [request+8],eax

	XSync dword [dpy], request, dword 12

	push eax
	MemoryFree request
	cmp eax,-1
	pop eax
	jne .end
	mov eax,-1
.end:
	__pop ecx, ebx
	ret


;;; Local Variables:
;;;  mode:asm
;;;  eval:(load-library "time-stamp")
;;;  eval:(make-local-variable 'write-file-hooks)
;;;  eval:(add-hook 'write-file-hooks 'time-stamp)
;;;  eval:(setq time-stamp-start "last modified:[ 	]+\\\\?[\"<]+")
;;;  eval:(setq time-stamp-format "%3a %3b %2d %02H:%02M:%02S %y")
;;; End: