;;;
;;; XDepthAddr.s
;;;
;;; created: <Tue Mar  7 15:27:23 2000>
;;; last modified: <Mon Apr 17 19:43:34 2000>
;;;
;;; Christian Fowelin <christian@fowelin.de>
;;;
;;; Released under the LGPL (file COPYING).
;;;

%include "system.h"
%include "x_struc_x.h"
%include "x_func.h"

global _XDepthAddr

%define dpy ebx+0
%define depth ebx+4
%define screen ebx+8

	section .text
	align 32
_XDepthAddr:
	__push ebx, ecx, edx
	mov ebx,eax

;;; First: Get adress of Screen
	XScreenAddr dword [dpy], dword [screen]
	cmp eax,-1
	je .end

;;; Second: Get adress of Depth
	mov edx,eax
	add edx,xWindowRoot_size
	movzx ecx,byte [eax+xWindowRoot.nDepths]
	mov eax,[depth]
.loop:
	cmp [edx+xDepth.depth],al
	je .gotit
	movzx ebx,word [edx+xDepth.nVisuals]
	imul ebx,dword xVisualType_size
	add edx,xDepth_size
	add edx,ebx
	dec ecx
	jnz .loop
	jmp short .error

.gotit:
	mov eax,edx

.end:
	__pop edx, ecx, ebx
	ret

.error:
	mov eax,-1
	jmp short .end


;;; Local Variables:
;;;  mode:asm
;;;  eval:(load-library "time-stamp")
;;;  eval:(make-local-variable 'write-file-hooks)
;;;  eval:(add-hook 'write-file-hooks 'time-stamp)
;;;  eval:(setq time-stamp-start "last modified:[ 	]+\\\\?[\"<]+")
;;;  eval:(setq time-stamp-format "%3a %3b %2d %02H:%02M:%02S %y")
;;; End: