;;;
;;; XDestroyWindow.s
;;;
;;; created: <Thu Mar  9 19:08:22 2000>
;;; last modified: <Thu May 18 10:36:04 2000>
;;;
;;; Christian Fowelin <christian@fowelin.de>
;;;
;;; Released under the LGPL (file COPYING).
;;;

%include "system.h"
%include "x_func.h"
%include "x_def.h"
%include "mem.h"

global _XDestroyWindow

%define dpy ebx+0
%define wid ebx+4

%define request ecx

	section .text
	align 32
_XDestroyWindow:
	__push ebx, ecx
	mov ebx,eax
	MemoryAllocate dword 8
	cmp eax,-1
	je .end
	mov request,eax

;;; Opcode: DestroyWindow
	mov [request+0],byte X_DestroyWindow
	mov [request+1],byte 0
;;; request length
	mov [request+2],word 2
;;; wid
	mov ebx,[wid]
	mov [request+4],ebx

	XSync dword [dpy], request, dword 4*2 ; 4*(request length)

	push eax
	MemoryFree request
	cmp eax,-1
	pop eax
	jne .end
	mov eax,-1
.end:
	__pop ecx, ebx
	ret



;;; Local Variables:
;;;  mode:asm
;;;  eval:(load-library "time-stamp")
;;;  eval:(make-local-variable 'write-file-hooks)
;;;  eval:(add-hook 'write-file-hooks 'time-stamp)
;;;  eval:(setq time-stamp-start "last modified:[ 	]+\\\\?[\"<]+")
;;;  eval:(setq time-stamp-format "%3a %3b %2d %02H:%02M:%02S %y")
;;; End: