;;;
;;; XFreeGC.s
;;;
;;; created: <Sat May 27 20:00:48 2000>
;;; last modified: <Fri Jun  9 22:44:28 2000>
;;;
;;; Christian Fowelin <christian@fowelin.de>
;;;
;;; Released under the LGPL (file COPYING).
;;;

%include "system.h"
%include "x_func.h"
%include "x_def.h"
%include "mem.h"

global _XFreeGC

%define dpy ebx+0
%define gc ebx+4

%define request ecx

	section .text
	align 32
_XFreeGC:
	__push ebx, ecx
	mov ebx,eax
	MemoryAllocate dword 4*2
	cmp eax,-1
	je near .end
	mov request,eax

;;; Opcode: FreeGC
	mov [request+0],byte X_FreeGC
;;; request length
	mov [request+2],word 2
;;; gc
	mov eax,[gc]
	mov [request+4],eax

	XSync dword [dpy], request, dword 4*2

	push eax
	MemoryFree request
	cmp eax,-1
	pop eax
	jne near .end
	mov eax,-1
.end:
	__pop ecx, ebx
	ret


;;; Local Variables:
;;;  mode:asm
;;;  eval:(load-library "time-stamp")
;;;  eval:(make-local-variable 'write-file-hooks)
;;;  eval:(add-hook 'write-file-hooks 'time-stamp)
;;;  eval:(setq time-stamp-start "last modified:[ 	]+\\\\?[\"<]+")
;;;  eval:(setq time-stamp-format "%3a %3b %2d %02H:%02M:%02S %y")
;;; End: