;;;
;;; XGetProperty.s
;;;
;;; created: <Mon Mar 20 14:23:09 2000>
;;; last modified: <Sat Jun 17 10:21:09 2000>
;;;
;;; Christian Fowelin <christian@fowelin.de>
;;;
;;; Released under the LGPL (file COPYING).
;;;

%include "system.h"
%include "mem.h"
%include "string.h"
%include "x_func.h"
%include "x_def.h"
%include "sys.h"

global _XGetProperty

%define dpy edx+0
%define wid edx+4
%define property edx+8
%define offset edx+12
%define length edx+16
%define delete edx+20
%define type edx+24
%define actual_type edx+28
%define actual_format edx+32
%define nitems edx+36
%define bytesafter edx+40
%define value edx+44

%define request esi
%define reply edi
%define replylength ebp

	section .text
	align 32
_XGetProperty:
	__push edx, esi, edi, ebp
	mov edx,eax
	MemoryAllocate dword 24
	cmp eax,-1
	je near .end
	mov request,eax

;;; opcode: GetProperty
	mov [request+0],byte X_GetProperty
;;; delete
	mov eax,[delete]
	mov [request+1],al
;;; request length
	mov [request+2],word 6
;;; wid
	mov eax,[wid]
	mov [request+4],eax
;;; property
	mov eax,[property]
	mov [request+8],eax
;;; type
	mov eax,[type]
	mov [request+12],eax
;;; offset
	mov eax,[offset]
	mov [request+16],eax
;;; length
	mov eax,[length]
	mov [request+20],eax

	XSync dword [dpy], request, dword 24
	push eax
	MemoryFree request
	cmp eax,-1
	pop eax
	jne .wait
	mov eax,-1
	jmp near .end
;;; Wait for that reply:
.wait:
	cmp eax,-1
	je near .end
	cmp eax,0
	jne .ok
	Sleep dword 0, dword 50	; :)
	XSync dword [dpy], dword 0, dword 0

	jmp short .wait		; Wait for reply!!!!
.ok:
	mov reply,eax

	cmp [eax+8],dword None
	jne .ok2
	MemoryFree eax		; Was nothing
	cmp eax,-1
	je near .end
	mov eax,[value]
	mov [eax],dword 0
	mov eax,[bytesafter]
	mov [eax],dword 0
	mov eax,[nitems]
	mov [eax],dword 0
	mov eax,[actual_format]
	mov [eax],dword 0
	mov eax,[actual_type]
	mov [eax],dword 0
	mov eax,0
	jmp .end

.ok2:
	__push ebx, ecx
	mov ebx,[actual_format]
	movzx ecx,byte [eax+1]
	cmp ebx,0
	je .p1
	mov [ebx],ecx
.p1:
	shr cl,3		; /8
	mov eax,[eax+16]
	mov ebx,[nitems]
	cmp ebx,0
	je .p2
	mov [ebx],eax
.p2:
	shl eax,cl
	inc eax			; \0 terminated
	mov replylength,eax
	mov ebx,[actual_type]
	mov ecx,[reply+8]
	cmp ebx,0
	je .p3
	mov [ebx],ecx
.p3:
	mov ebx,[bytesafter]
	mov ecx,[reply+12]
	cmp ebx,0
	je .p4
	mov [ebx],ecx
.p4:

	mov eax,reply
	add eax,byte 32
	mov ebx,[value]
	mov ecx,replylength
	dec ecx
	Strncpy eax, ebx, ecx
	__pop ecx, ebx

	MemoryFree reply
	cmp eax,-1
	je .end
	mov eax,0

.end:
	__pop ebp, edi, esi, edx
	ret


;;; Local Variables:
;;;  mode:asm
;;;  eval:(load-library "time-stamp")
;;;  eval:(make-local-variable 'write-file-hooks)
;;;  eval:(add-hook 'write-file-hooks 'time-stamp)
;;;  eval:(setq time-stamp-start "last modified:[ 	]+\\\\?[\"<]+")
;;;  eval:(setq time-stamp-format "%3a %3b %2d %02H:%02M:%02S %y")
;;; End: