;;;
;;; XGetScanlinePad.s
;;;
;;; created: <Fri Jul 28 20:21:36 2000>
;;; last modified: <Fri Jul 28 20:34:36 2000>
;;;
;;; Christian Fowelin <christian@fowelin.de>
;;;
;;; Released under the LGPL (file COPYING).
;;;

%include "system.h"
%include "x_struc.h"

global _XGetScanlinePad

%define dpy eax+0
%define depth eax+4

	section .text
	align 32
_XGetScanlinePad:
	__push ebx, ecx, esi

	mov ebx,[dpy]
	mov eax,[depth]
	mov ecx,[ebx+dpystruc.nformats]
	mov esi,[ebx+dpystruc.pformats]

;;; Scan xPixmapFormats for depth
.scan:
	cmp [esi+xPixmapFormat.depth],al
	jne .next

;;; Return .scanLinePad
	movzx eax,byte [esi+xPixmapFormat.scanLinePad]
	jmp short .end

.next:
	add esi,byte xPixmapFormat_size
	dec ecx
	jnz .scan

;;; If depth is not found, return dpystruc.bitmapScanlinePad
	mov eax,[ebx+dpystruc.bitmapScanlinePad]

.end:
	__pop esi, ecx, ebx
	ret


;;; Local Variables:
;;;  mode:asm
;;;  eval:(load-library "time-stamp")
;;;  eval:(make-local-variable 'write-file-hooks)
;;;  eval:(add-hook 'write-file-hooks 'time-stamp)
;;;  eval:(setq time-stamp-start "last modified:[ 	]+\\\\?[\"<]+")
;;;  eval:(setq time-stamp-format "%3a %3b %2d %02H:%02M:%02S %y")
;;; End: