;;;
;;; XPolyPoint.s
;;;
;;; created: <Sat Jun 17 07:41:31 2000>
;;; last modified: <Sat Jun 17 14:23:26 2000>
;;;
;;; Christian Fowelin <christian@fowelin.de>
;;;
;;; Released under the LGPL (file COPYING).
;;;

%include "system.h"
%include "x_func.h"
%include "x_def.h"
%include "mem.h"

global _XPolyPoint

%define dpy ebx+0
%define wid ebx+4
%define gc ebx+8
%define cmode ebx+12
%define npoints ebx+16
%define points ebx+20

%define request ecx

	section .text
	align 32
_XPolyPoint:
	__push ebx, ecx, edx, esi
	mov ebx,eax
	mov eax,[npoints]
	add eax,byte 3
	mov edx,eax
	shl eax,4
	MemoryAllocate eax
	cmp eax,-1
	je near .end
	mov request,eax

;;; Opcode: PolyPoint
	mov [request+0],byte X_PolyPoint
;;; coordinate mode
	mov eax,[cmode]
	mov [request+1],al
;;; request length
	mov [request+2],dx
;;; wid
	mov eax,[wid]
	mov [request+4],eax
;;; gc
	mov eax,[gc]
	mov [request+8],eax
;;; points
;;; List of points x,y: libASM 32:32, Xserver 16:16
	sub edx,byte 3
	jz .nocopy		; if 0 don't copy any points
	mov esi,[points]
.copyloop:
	mov eax,[esi+(edx*8)+4-8]
	shl eax,16
	mov ax,[esi+(edx*8)+0-8]
	mov [request+12+(edx*4)-4],eax
	dec edx
	jnz .copyloop
.nocopy:
	mov eax,[npoints]
	add eax,byte 3
	shl eax,2
	XSync dword [dpy], request, eax

	push eax
	MemoryFree request
	cmp eax,-1
	pop eax
	jne near .end
	mov eax,-1
.end:
	__pop esi, edx, ecx, ebx
	ret


;;; Local Variables:
;;;  mode:asm
;;;  eval:(load-library "time-stamp")
;;;  eval:(make-local-variable 'write-file-hooks)
;;;  eval:(add-hook 'write-file-hooks 'time-stamp)
;;;  eval:(setq time-stamp-start "last modified:[ 	]+\\\\?[\"<]+")
;;;  eval:(setq time-stamp-format "%3a %3b %2d %02H:%02M:%02S %y")
;;; End: