;;;
;;; XReparentWindow.s
;;;
;;; created: <Fri May 26 19:09:04 2000>
;;; last modified: <Fri May 26 19:11:30 2000>
;;;
;;; Christian Fowelin <christian@fowelin.de>
;;;
;;; Released under the LGPL (file COPYING).
;;;

%include "system.h"
%include "x_func.h"
%include "x_def.h"
%include "mem.h"

global _XReparentWindow

%define dpy ebx+0
%define wid ebx+4
%define parent ebx+8
%define x ebx+12
%define y ebx+16

%define request ecx

	section .text
	align 32
_XReparentWindow:
	__push ebx, ecx
	mov ebx,eax
	MemoryAllocate dword 4*4
	cmp eax,-1
	je .end
	mov request,eax

;;; Opcode: ReparentWindow
	mov [request+0],byte X_ReparentWindow
;;; request length
	mov [request+2],word 4
;;; wid
	mov eax,[wid]
	mov [request+4],eax
;;; parent
	mov eax,[parent]
	mov [request+8],eax
;;; x
	mov eax,[x]
	mov [request+12],ax
;;; y
	mov eax,[y]
	mov [request+14],ax

	XSync dword [dpy], request, dword 4*4 ; 4*(request length)

	push eax
	MemoryFree request
	cmp eax,-1
	pop eax
	jne .end
	mov eax,-1
.end:
	__pop ecx, ebx
	ret


;;; Local Variables:
;;;  mode:asm
;;;  eval:(load-library "time-stamp")
;;;  eval:(make-local-variable 'write-file-hooks)
;;;  eval:(add-hook 'write-file-hooks 'time-stamp)
;;;  eval:(setq time-stamp-start "last modified:[ 	]+\\\\?[\"<]+")
;;;  eval:(setq time-stamp-format "%3a %3b %2d %02H:%02M:%02S %y")
;;; End: