;;;
;;; XShmDetach.s
;;;
;;; created: <Mon Aug 21 23:26:30 2000>
;;; last modified: <Mon Aug 21 23:28:15 2000>
;;;
;;; Christian Fowelin <christian@fowelin.de>
;;;
;;; Released under the LGPL (file COPYING).
;;;

%include "system.h"
%include "x_func.h"
%include "x_def.h"
%include "x_struc.h"
%include "mem.h"

global _XShmDetach

extern _errno

%define dpy ebx+0
%define shminfo ebx+4

%define request ecx

	section .text
	align 32
_XShmDetach:
	__push ebx, ecx, edx
	mov ebx,eax

;;; MIT-SHM Extension availible?
	mov eax,[dpy]
	cmp [eax+dpystruc.MIT_SHM_opcode],dword 0
	je near .notavail		; No :(
	
	MemoryAllocate dword 4*2
	cmp eax,-1
	je .end
	mov request,eax

	XAllocID [dpy]
	mov edx,[shminfo]
	mov [edx+XShmSegmentInfo.shmseg],eax

;;; Opcode: ShmDetach
	mov eax,[dpy]
	mov eax,[eax+dpystruc.MIT_SHM_opcode]
	mov [request+0],al
	mov [request+1],byte X_ShmDetach
;;; request length
	mov [request+2],word 2
;;; shmseg
	mov eax,[edx+XShmSegmentInfo.shmseg]
	mov [request+4],eax

	XSync dword [dpy], request, dword 4*2 ; 4*(request length)

	push eax
	MemoryFree request
	cmp eax,-1
	pop eax
	jne .end
	mov eax,-1
.end:
	__pop edx, ecx, ebx
	ret

.notavail:
	mov [_errno],dword -ENOPROTOOPT
	mov eax,-1
	jmp short .end


;;; Local Variables:
;;;  mode:asm
;;;  eval:(load-library "time-stamp")
;;;  eval:(make-local-variable 'write-file-hooks)
;;;  eval:(add-hook 'write-file-hooks 'time-stamp)
;;;  eval:(setq time-stamp-start "last modified:[ 	]+\\\\?[\"<]+")
;;;  eval:(setq time-stamp-format "%3a %3b %2d %02H:%02M:%02S %y")
;;; End: