﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace binviz.searcher
{
	class AbstractSearch : Search
	{

        /// <summary>
        /// Returns a user friendly name of the type of search provided. This method
        /// should NEVER return a null or an empty string as it's output is used for
        /// UI rendering.
        /// </summary>
        /// <returns>String</returns>
        abstract String getName();

		/// <summary>
		/// Returns a Collection of search results given the byte array to look for. An error MUST
		/// be thrown if either byte array is less than size 1 or contains null elements.
		/// </summary>
		/// <param name="vab_bytes_to_find">byte array of elements to find in the specific order provided</param>
		/// <param name="vab_to_search">byte array to search for the given elements</param>
		/// <returns>an IList of SearchResult objects</returns>
		abstract IList<SearchResult> getResults(byte[] vab_bytes_to_find, byte[] vab_to_search);
	}
}
